<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" xmlns:gri="http://java.sun.com/jsf/composite/gri">
    <!-- params
          - managedBean: the java bean which implements HPDInitiator interface -->
    <!-- inserts:
          - additionalButtonsOnReport: buttons to be inserted in the report panel below the dataTable, on the right hand of the "perform another test" button
          - additionalPanels: extra panels to be added at the bottom of the page
          - requestConfig: the part of the page which allows the user to configure each part of the batchRequest -->
    <h:form>
        <s:div id="globalDiv">
            <h1>#{managedBean.simulatedActor.name}</h1>
            <gri:panel pid="createRequestPanel">
                <f:facet name="header">Create downloadRequest</f:facet>
                <s:div styleClass="row" id="sequenceDiagram">
                    <div class="col-lg-4">
                        <gri:panel pid="simConfPanel">
                            <f:facet name="header">#{messages['net.ihe.gazelle.hpd.Simulator']}</f:facet>
                            <dl class="dl-horizontal">
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.Name']}</ui:define>
                                    <h:outputText value="#{messages['net.ihe.gazelle.hpd.HPDSimulator']}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.simulators.Role']}</ui:define>
                                    <h:outputText value="#{managedBean.simulatedActor.name}"/>
                                </s:decorate>
                            </dl>
                        </gri:panel>
                    </div>
                    <div class="col-md-4">
                        <h:graphicImage library="img" name="diag/#{managedBean.simulatedActor.keyword}.png"/>
                    </div>
                    <div class="col-lg-4">
                        <gri:panel pid="sutConfig" rendered="#{managedBean.selectedSut != null}">
                            <f:facet name="header">#{messages['net.ihe.gazelle.hpd.SystemUnderTestSUT']})</f:facet>
                            <dl class="dl-horizontal">
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.Name']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.name}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.simulator.System']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.systemName}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.simulator.URL']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.url}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.BaseDN']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.baseDN}"/>
                                </s:decorate>
                            </dl>
                        </gri:panel>
                    </div>
                </s:div>
                <div class="form-horizontal">
                    <s:decorate id="configSelectionDecorate" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.hpd.SystemUnderTest']}</ui:define>
                        <ui:param name="id" value="configSelectionBox"/>
                        <h:selectOneMenu id="configSelectionBox" value="#{managedBean.selectedSut}"
                                         styleClass="form-control gzl-select-text">
                            <s:selectItems value="#{managedBean.listAvailableSut()}" var="sut" label="#{sut.name}"
                                           noSelectionLabel="#{messages['net.ihe.gazelle.hpd.PleaseSelect']}"/>
                            <a4j:ajax event="change"
                                      execute="@this"
                                      render="sequenceDiagram, downloadRequestOption"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </div>

                <gri:panel pid="downloadRequestOption">
                    <f:facet name="header">
                        <h:outputText value="Download Request Option"/>
                    </f:facet>
                    <div class="form-horizontal">
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:param name="id" value="fromDate"/>
                            <ui:define name="label">From date</ui:define>
                            <a4j:outputPanel id="fromDatePanel" layout="block">
                                <rich:calendar id="fromDate" value="#{managedBean.downloadRequest.fromDateDate}"
                                               datePattern="yyyy/MM/dd hh:mm:ss"
                                               showApplyButton="false" required="true"
                                               requiredMessage="You shall populate fromDate (mandatory field)">
                                </rich:calendar>
                            </a4j:outputPanel>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:param name="id" value="toDate"/>
                            <ui:define name="label">To date</ui:define>
                            <a4j:outputPanel id="todatePanel" layout="block">
                                <rich:calendar id="toDate" value="#{managedBean.downloadRequest.toDateDate}"
                                               datePattern="yyyy/MM/dd hh:mm:ss"
                                               showApplyButton="false">
                                </rich:calendar>
                            </a4j:outputPanel>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_checkbox_horizontal_inline.xhtml">
                            <h:selectBooleanCheckbox value="#{managedBean.downloadRequest.filterMyTransactions}"/>
                            Filter the transaction ?
                        </s:decorate>

                        <h:commandButton value="Add authRequest" action="#{managedBean.addAuthRequest()}"
                                         styleClass="gzl-btn-green"
                                         rendered="#{managedBean.getDownloadRequest().authRequest == null}"/>

                        <s:decorate template="/layout/panels/_panel_title_id.xhtml"
                                    rendered="#{managedBean.downloadRequest.authRequest != null}">
                            <ui:param name="panel_id" value="authRequestPanel"/>
                            <ui:define name="panel_title">
                                <h:outputText value="AuthRequest"/>
                                <a4j:commandLink
                                        actionListener="#{managedBean.deleteAuthRequest()}"
                                        render="downloadRequestOption"
                                        immediate="true">
                                    <s:span styleClass="pull-right gzl-icon-trash-o"
                                            title="#{messages['net.ihe.gazelle.hpd.RemoveRequestFromBatch']}"/>
                                </a4j:commandLink>
                            </ui:define>

                            <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                <ui:param name="id" value="principal"/>
                                <ui:define name="label">Principal</ui:define>
                                <h:inputText value="#{managedBean.downloadRequest.authRequest.principal}"
                                             id="principal"
                                             styleClass="form-control" required="true"
                                             requiredMessage="You shall populate the principal (mandatory field)"/>
                            </s:decorate>

                            <div class="col-lg-2 scrollspy">
                                <nav class="gzl-sidebar" id="nav-sidebar">
                                    <ul class="nav" id="nav">
                                        <h:commandButton value="Add control"
                                                         action="#{managedBean.addControl()}"
                                                         styleClass="gzl-btn-green"/>
                                    </ul>
                                </nav>
                            </div>
                            <div class="col-lg-10">
                                <a4j:repeat value="#{managedBean.downloadRequest.authRequest.control}"
                                            var="currentControl">
                                    <div id="control">
                                        <gri:panel pid="requestConfPanel">
                                            <f:facet name="header">
                                                <h:outputText
                                                        value="Control"/>
                                                <a4j:commandLink
                                                        actionListener="#{managedBean.removeControl(currentControl)}"
                                                        render="authRequestPanel"
                                                        immediate="true">
                                                    <s:span styleClass="pull-right gzl-icon-trash-o"
                                                            title="#{messages['net.ihe.gazelle.hpd.RemoveRequestFromBatch']}"/>
                                                </a4j:commandLink>
                                            </f:facet>
                                            <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                                <ui:param name="id" value="controlValueID"/>
                                                <ui:define name="label">Control Value</ui:define>
                                                <h:inputText value="#{currentControl.controlValue}"
                                                             id="controlValueID"
                                                             styleClass="form-control" required="false"/>
                                            </s:decorate>
                                            <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                                <ui:param name="id" value="typeID"/>
                                                <ui:define name="label">Type</ui:define>
                                                <h:inputText value="#{currentControl.type}" id="typeID"
                                                             requiredMessage="You shall populate typeID (mandatory field)"
                                                             styleClass="form-control" required="true"/>
                                            </s:decorate>
                                            <s:decorate
                                                    template="/layout/form/_form_checkbox_horizontal_inline.xhtml">
                                                <h:selectBooleanCheckbox value="#{currentControl.criticality}"/>
                                                Criticality
                                            </s:decorate>
                                        </gri:panel>
                                    </div>
                                </a4j:repeat>
                            </div>

                        </s:decorate>
                    </div>
                    <f:facet name="footer">
                        <a4j:commandButton id="sendButton"
                                           value="#{messages['net.ihe.gazelle.hpd.SendRequest']}"
                                           rendered="#{managedBean.selectedSut != null and not empty managedBean.downloadRequest}"
                                           actionListener="#{managedBean.sendMessage()}"
                                           render="globalDiv" styleClass="gzl-btn-blue"/>
                    </f:facet>
                </gri:panel>
                <div>
                    <gri:panel pid="reportPanel" rendered="#{not empty managedBean.messages}">
                        <f:facet name="header">#{messages['net.ihe.gazelle.hpd.TestReport']}</f:facet>
                        <rich:dataTable value="#{managedBean.messages}" var="ti" rows="20"
                                        id="tableTransactionsSend"
                                        render="ds">
                            <ui:include src="/messages/logger_columns.xhtml">
                                <ui:param name="managedBean" value="#{hpdMessageBrowser}"/>
                            </ui:include>
                            <g:column>
                                <f:facet name="header">Action</f:facet>
                                <h:outputLink value="#{hpdMessageBrowser.permanentLink(ti)}" target="_blank;">
                                    <s:span styleClass="gzl-icon-search "/>
                                </h:outputLink>
                                <a4j:commandLink actionListener="#{hpdMessageBrowser.validate(ti)}"
                                                 oncomplete="jq162('#validationSummaryPanel').modal('show')"
                                                 render="validationSummaryPanelContent">
                                    <s:span styleClass="fa fa-play gzl-text-blue"/>
                                </a4j:commandLink>
                            </g:column>
                        </rich:dataTable>
                        <ui:include src="/messages/validationSummaryPanel.xhtml">
                            <ui:param name="managedBean" value="#{hpdMessageBrowser}"/>
                        </ui:include>
                        <f:facet name="footer">
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.PerformAnotherTest']}"
                                               actionListener="#{managedBean.performAnotherTest()}"
                                               render="globalDiv" styleClass="gzl-btn-blue"/>
                        </f:facet>
                    </gri:panel>
                    <ui:insert name="additionalPanels"/>
                </div>
            </gri:panel>
        </s:div>
    </h:form>
</ui:composition>